Subject: bug#56648: 29.0.50; Need for `compiled-function-p`

From: Stefan Monnier <[email-masked]>
Date: Sun, 14 Aug 2022 13:51:57 -0400

>> -  (or (byte-code-function-p (symbol-function 'byte-compile-form))
>> -      (subr-native-elisp-p (symbol-function 'byte-compile-form))
>> -      (assq 'byte-code (symbol-function 'byte-compile-form)) <<<<<<<<<<<<<

According to my reading of the code, this `assq` can never return
non-nil.

I think it was a left-over from many years ago when the byte-compiler
cuold generated code of the form (lambda (..) (byte-code ...)).

Strictly speaking we still occasionally generate such (byte-code ...)
thingies, but only in cases that don't apply here (e.g. it's not applied
for functions, see `byte-compile-out-toplevel`).

        Stefan